package iterator;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.junit.Test;

public class IteratorTest {

    private final int MAX_EXECUTION_TIME = 1 * 1000; // in milliseconds

	@Test(timeout = MAX_EXECUTION_TIME)
	public void testTinyUniversity() {

        University tinyUniversity = new University();
        Course ppCourse = new Course("PROG_PARADIGM");
        Course seCourse = new Course("SOFT_ENG");
        Course algoCourse = new Course("ALGO");
        Course mlCourse = new Course("ML");
        tinyUniversity.addCourse(ppCourse);
        tinyUniversity.addCourse(seCourse);
        tinyUniversity.addCourse(algoCourse);
        tinyUniversity.addCourse(mlCourse);

        ppCourse.addStudentMark("pp_student1", 10);
        ppCourse.addStudentMark("pp_student2", 9);
        ppCourse.addStudentMark("pp_student3", 8);

        seCourse.addStudentMark("se_student1", 10);
        seCourse.addStudentMark("se_student2", 2);
        seCourse.addStudentMark("se_student3", 1);

        algoCourse.addStudentMark("algo_student1", 5);
        algoCourse.addStudentMark("algo_student2", 6);

        mlCourse.addStudentMark("ml_student1", 7);

        List<Integer> expectedMarks = Arrays.asList(10, 9, 8, 10, 2, 1, 5, 6, 7);


		List<Integer> actualMarks = new ArrayList<Integer>();
        for (Integer mark : tinyUniversity) {
            actualMarks.add(mark);
        }

        System.out.println("EXPECTED");
		Collections.sort(expectedMarks);
        System.out.println(expectedMarks);

        System.out.println("ACTUAL");
		Collections.sort(actualMarks);
		System.out.println(actualMarks);



		assertEquals(expectedMarks.size(), actualMarks.size());
		assertArrayEquals(expectedMarks.toArray(), actualMarks.toArray());

	}
}
