from course import Course
from university import University

"""
To run this test go to open the current folder in the terminal and use:
  pytest
If you want to see also the printout of your algorithm use:
  pytest -s
"""


def test_tiny_university():
    """Get all the marks given in a super small university."""

    tiny_uni = University()

    pp_course = Course("PROG_PARADIGM")
    se_course = Course("SOFT_ENG")
    algo_course = Course("ALGO")
    ml_course = Course("ML")
    tiny_uni.add_course(pp_course)
    tiny_uni.add_course(se_course)
    tiny_uni.add_course(algo_course)
    tiny_uni.add_course(ml_course)

    pp_course.add_mark("pp_student1", 10)
    pp_course.add_mark("pp_student2", 9)
    pp_course.add_mark("pp_student3", 8)

    se_course.add_mark("se_student1", 10)
    se_course.add_mark("se_student2", 2)
    se_course.add_mark("se_student3", 1)

    algo_course.add_mark("algo_student1", 5)
    algo_course.add_mark("algo_student2", 6)

    ml_course.add_mark("ml_student1", 7)

    expected_marks = [10, 9, 8, 10, 2, 1, 5, 6, 7]

    actual_marks = []
    for mark in tiny_uni.iterate_marks():
        actual_marks.append(mark)
        print(mark)

    expected_marks.sort()
    actual_marks.sort()

    print('EXPECTED')
    print(expected_marks)
    print('ACTUAL')
    print(actual_marks)

    assert len(expected_marks) == len(actual_marks)
    assert all([a == b for a, b in zip(expected_marks, actual_marks)])
